class K2
{
  float[] posX;
  float[] posY;
  float[] speedX;
  float[] speedY;
  float[] angles;

  float angle = 0;      
  float offset = 0;     

  // バネの硬さを定めます
  float stiffness = 0.4;

  // バネの摩擦係数を定めます（減衰の程度）
  float damping = 0.9;

  // 円の重さを定めます
  float mass = 12.0;

  // 
  int bufferSize;

  K2(int _bufferSize)
  {
    bufferSize = _bufferSize;

    posX = new float[BUFSIZE];
    posY = new float[BUFSIZE];
    speedX = new float[BUFSIZE];
    speedY = new float[BUFSIZE];
    angles = new float[BUFSIZE];

    for (int i = 0; i < bufferSize; i++)
    {
      posX[i] = 0;
      posY[i] = 0;
      speedX[i] = 0;
      speedY[i] = 0;
      angles[i] = radians(random(0, 360));
    }
  }

  Position spring(int cw, int ch, int i, float specSize, float getBand)
  {
    // 音量に基づいてバネにかかる力を定めます
    float addFroce = getBand* i * cw/float(bufferSize)/2.0;

    // 外側に向かう方向（角度）をランダムにします
    float direction = radians(random(0, 360));

    // 力と角度に基づいて、円の中心位置を取得します
    float addX = cos(direction) * addFroce;
    float addY = sin(direction) * addFroce;

    float forceX = stiffness * -posX[i] + addX;
    float accelerationX = forceX / mass;
    speedX[i] = damping * (speedX[i] + accelerationX);

    float forceY = stiffness * -posY[i] + addY;
    float accelerationY = forceY / mass;
    speedY[i] = damping * (speedY[i] + accelerationY);

    posX[i] += speedX[i];
    posY[i] += speedY[i];

    return new Position(posX[i], posY[i]);
  }

  // 背景の塗りつぶし方法を定めます
  void backgroundFade(int cw, int ch, int ba)
  {
    // 線を描きません
    noStroke();

    // 不透明度 5 の黒を指定し、
    fill(0, 0, 0, ba);

    // キャンバスサイズ一杯の四角形を描画します  
    rect(0, 0, width, height);
  }


  void beginRotation()
  {
    pushMatrix();
    rotateY(radians(angle * mouseX/float(width) + offset));
    rotateX(radians(angle * mouseY/float(height) + offset));
    rotateZ(radians(angle / 10.0 + offset));
  }

  void endRotation()
  {
    popMatrix();
  }

  void saveFrames(boolean saveFlag)
  {
    if (saveFlag)
      saveFrame();
  }
}

class Position
{
  float x, y;

  Position(float _posX, float _posY)
  {
    x = _posX;
    y = _posY;
  }
}

